import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import java.util.ArrayList;

public class MessreiheDreierTest{
    private Messreihe m55113;
    private Messreihe m27;
    private Messreihe m2444;
    private Messreihe m3;
    private Messreihe leer;
    private Messreihe mitNullListe;
  private ArrayList<Integer> genutzt;

  private void merkeGenutzteWerte(Messreihe m){
    if (m.getMesswerte() == null){
      return;
    }
    for (int w: m.getMesswerte()) { // in Messreihe keine null-Werte
      this.genutzt.add(w);
    }
  }
  
  private boolean messwerteUnveraendert(Messreihe m){
    if (m.getMesswerte() == null){
      return this.genutzt.size() == 0;
    }
    for(int i = 0; i < this.genutzt.size(); i++) {
      if (this.genutzt.get(i) != m.getMesswerte().get(i)){
        return false;
      }
    }
    return m.getMesswerte().size() == this.genutzt.size();
  }
  
  @BeforeEach
  public void setUp() {
    this.genutzt = new ArrayList<Integer>();
        this.m55113 = new Messreihe("Ort1");
        this.m55113.hinzufuegen(5);
        this.m55113.hinzufuegen(5);
        this.m55113.hinzufuegen(1);
        this.m55113.hinzufuegen(1);
        this.m55113.hinzufuegen(3);
        this.m27 = new Messreihe("Ort2");
        this.m27.hinzufuegen(2);
        this.m27.hinzufuegen(7);
        this.m2444 = new Messreihe("Ort3");
        this.m2444.hinzufuegen(2);
        this.m2444.hinzufuegen(4);
        this.m2444.hinzufuegen(4);
        this.m2444.hinzufuegen(4);   
        this.leer = new Messreihe("Ort4");
        this.mitNullListe = new Messreihe("Ort5");
        this.mitNullListe.setMesswerte(null);
        this.m3 = new Messreihe("Ort6");
        this.m3.hinzufuegen(3);
    }

    @Test
    public void test01(){
        this.merkeGenutzteWerte(this.mitNullListe);
        Assertions.assertTrue(!this.mitNullListe.dreier(0)
            , "Drei Werte von " + this.mitNullListe +" ergeben nicht 0 ");
        Assertions.assertTrue(this.messwerteUnveraendert(this.mitNullListe)
            , "urspruengliche Werte " + this.genutzt 
              + " sollten nicht geaendert werden:" + this.mitNullListe);    
    }
    
    @Test
    public void test02(){
        this.merkeGenutzteWerte(this.leer);
        Assertions.assertTrue(!this.leer.dreier(0)
            , "Drei Werte von " + this.leer +" ergeben nicht 0 ");
        Assertions.assertTrue(this.messwerteUnveraendert(this.leer)
            , "urspruengliche Werte " + this.genutzt 
              + " sollten nicht geaendert werden:" + this.leer);    
    }
    
    @Test
    public void test03(){
        this.merkeGenutzteWerte(this.m3);
        Assertions.assertTrue(!this.m3.dreier(3)
            , "Drei Werte von " + this.m3 +" ergeben nicht 3 ");
        Assertions.assertTrue(this.messwerteUnveraendert(this.m3)
            , "urspruengliche Werte " + this.genutzt 
              + " sollten nicht geaendert werden:" + this.m3);    
    }
    
    @Test
    public void test04(){
        this.merkeGenutzteWerte(this.m27);
        Assertions.assertTrue(!this.m27.dreier(9)
            , "Drei Werte von " + this.m27 +" ergeben nicht 9 ");
        Assertions.assertTrue(this.messwerteUnveraendert(this.m27)
            , "urspruengliche Werte " + this.genutzt 
              + " sollten nicht geaendert werden:" + this.m27);    
    }
    
    @Test
    public void test05(){
        this.merkeGenutzteWerte(this.m2444);
        Assertions.assertTrue(!this.m2444.dreier(14)
            , "Drei Werte von " + this.m2444 +" ergeben nicht 14 ");
        Assertions.assertTrue(this.messwerteUnveraendert(this.m2444)
            , "urspruengliche Werte " + this.genutzt 
              + " sollten nicht geaendert werden:" + this.m2444);    
    }
    
    @Test
    public void test06(){
        this.merkeGenutzteWerte(this.m2444);
        Assertions.assertTrue(this.m2444.dreier(10)
            , "Drei Werte von " + this.m2444 +" ergeben 10 ");
        Assertions.assertTrue(this.messwerteUnveraendert(this.m2444)
            , "urspruengliche Werte " + this.genutzt 
              + " sollten nicht geaendert werden:" + this.m2444);    
    }
    
    @Test
    public void test07(){
        this.merkeGenutzteWerte(this.m2444);
        Assertions.assertTrue(this.m2444.dreier(12)
            , "Drei Werte von " + this.m2444 +" ergeben 12 ");
        Assertions.assertTrue(this.messwerteUnveraendert(this.m2444)
            , "urspruengliche Werte " + this.genutzt 
              + " sollten nicht geaendert werden:" + this.m2444);     
    }
    
    @Test
    public void test08(){
        this.merkeGenutzteWerte(this.m55113);
        Assertions.assertTrue(!this.m55113.dreier(10)
            , "Drei Werte von " + this.m55113 +" ergeben nicht 10 ");
        Assertions.assertTrue(this.messwerteUnveraendert(this.m55113)
            , "urspruengliche Werte " + this.genutzt 
              + " sollten nicht geaendert werden:" + this.m55113);     
    }
    
    @Test
    public void test09(){
        this.merkeGenutzteWerte(this.m55113);
        Assertions.assertTrue(!this.m55113.dreier(15)
            , "Drei Werte von " + this.m55113 +" ergeben nicht 15 ");
        Assertions.assertTrue(this.messwerteUnveraendert(this.m55113)
            , "urspruengliche Werte " + this.genutzt 
              + " sollten nicht geaendert werden:" + this.m55113);     
    }
    
    @Test
    public void test10(){
        this.merkeGenutzteWerte(this.m55113);
        Assertions.assertTrue(this.m55113.dreier(11)
            , "Drei Werte von " + this.m55113 +" ergeben 11 ");
        Assertions.assertTrue(this.messwerteUnveraendert(this.m55113)
            , "urspruengliche Werte " + this.genutzt 
              + " sollten nicht geaendert werden:" + this.m55113); 
    }
    
    @Test
    public void test11(){
        this.merkeGenutzteWerte(this.m55113);
        Assertions.assertTrue(this.m55113.dreier(5)
            , "Drei Werte von " + this.m55113 +" ergeben 5 ");
        Assertions.assertTrue(this.messwerteUnveraendert(this.m55113)
            , "urspruengliche Werte " + this.genutzt 
              + " sollten nicht geaendert werden:" + this.m55113);     
    }
    
    @Test
    public void test12(){
        this.merkeGenutzteWerte(this.m55113);
        Assertions.assertTrue(this.m55113.dreier(9)
            , "Drei Werte von " + this.m55113 +" ergeben 9 ");
        Assertions.assertTrue(this.messwerteUnveraendert(this.m55113)
            , "urspruengliche Werte " + this.genutzt 
              + " sollten nicht geaendert werden:" + this.m55113);    
    }
    
    @Test
    public void test13(){
        Messreihe m = new Messreihe();
        m.hinzufuegen(4);
        m.hinzufuegen(5);
        m.hinzufuegen(6);
        this.merkeGenutzteWerte(m);
        Assertions.assertTrue(m.dreier(15)
            , "Drei Werte von " + m +" ergeben 15 ");
        Assertions.assertTrue(this.messwerteUnveraendert(m)
            , "urspruengliche Werte " + this.genutzt 
              + " sollten nicht geaendert werden:" + m);    
    } 
    
    @Test
    public void test14(){
        Messreihe m = new Messreihe();
        m.hinzufuegen(4);
        m.hinzufuegen(5);
        m.hinzufuegen(7);
        this.merkeGenutzteWerte(m);
        Assertions.assertTrue(!m.dreier(15)
            , "Drei Werte von " + m +" ergeben nicht15 ");
        Assertions.assertTrue(this.messwerteUnveraendert(m)
            , "urspruengliche Werte " + this.genutzt 
              + " sollten nicht geaendert werden:" + m);
    } 

    @Test
    public void test15(){
        Messreihe m = new Messreihe("test15");
        m.hinzufuegen(15);
        m.hinzufuegen(1);
        m.hinzufuegen(1);
        this.merkeGenutzteWerte(m);
        Assertions.assertTrue(!m.dreier(15)
            , "Drei Werte von " + m +" ergeben nicht 15 ");
        Assertions.assertTrue(this.messwerteUnveraendert(m)
            , "urspruengliche Werte " + this.genutzt 
              + " sollten nicht geaendert werden:" + m);    
    } 
    
    @Test
    public void test16(){
        Messreihe m = new Messreihe("test16");
        m.hinzufuegen(7);
        m.hinzufuegen(6);
        m.hinzufuegen(3);
        this.merkeGenutzteWerte(m);
        Assertions.assertTrue(!m.dreier(15)
            , "Drei Werte von " + m +" ergeben nicht 15 ");
        Assertions.assertTrue(this.messwerteUnveraendert(m)
            , "urspruengliche Werte " + this.genutzt 
              + " sollten nicht geaendert werden:" + m);    
    }  
    
    @Test
    public void test17(){
        Messreihe m = new Messreihe("test17");
        m.hinzufuegen(5);
        m.hinzufuegen(1);
        m.hinzufuegen(5);
        m.hinzufuegen(1);
        m.hinzufuegen(5);
        this.merkeGenutzteWerte(m);
        Assertions.assertTrue(m.dreier(15)
            , "Drei Werte von " + m +" ergeben 15 ");
        Assertions.assertTrue(this.messwerteUnveraendert(m)
            , "urspruengliche Werte " + this.genutzt 
              + " sollten nicht geaendert werden:" + m);
    }  

    @Test
    public void testDreierNeu() {
      Messreihe m = new Messreihe("");
      m.hinzufuegen(1);
      m.hinzufuegen(10);
      m.hinzufuegen(20);
      m.hinzufuegen(2);
      m.hinzufuegen(10);
      m.hinzufuegen(20);
      m.hinzufuegen(3);
      this.merkeGenutzteWerte(m);
      Assertions.assertTrue(m.dreier(6)
          , "Drei Werte von " + m +" ergeben 6 ");
      Assertions.assertTrue(this.messwerteUnveraendert(m)
        , "urspruengliche Werte " + this.genutzt 
          + " sollten nicht geaendert werden:" + m);	        
    }    
}
