import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import java.util.List;
import java.util.ArrayList;

public class MessreiheWerteNachHintenTest {
  private Messreihe m33244;
  private Messreihe m27;
  private Messreihe m2344;
  private Messreihe m3;
  private Messreihe leer;
  private Messreihe mitNullListe;

  @BeforeEach
  public void setUp(){
    this.m33244 = new Messreihe("Ort1");
    this.m33244.hinzufuegen(3);
    this.m33244.hinzufuegen(3);
    this.m33244.hinzufuegen(2);
    this.m33244.hinzufuegen(4);
    this.m33244.hinzufuegen(4);
    this.m27 = new Messreihe("Ort2");
    this.m27.hinzufuegen(2);
    this.m27.hinzufuegen(7);
    this.m2344 = new Messreihe("Ort3");
    this.m2344.hinzufuegen(2);
    this.m2344.hinzufuegen(3);
    this.m2344.hinzufuegen(4);
    this.m2344.hinzufuegen(4);   
    this.leer = new Messreihe("Ort4");
    this.mitNullListe = new Messreihe("Ort5");
    this.mitNullListe.setMesswerte(null);
    this.m3 = new Messreihe("Ort6");
    this.m3.hinzufuegen(3);
    List.of();
  }

  @Test
  public void test01(){
    List<Integer> vorher = (List<Integer>) this.m33244.getMesswerte().clone();
    List<Integer> erwartet = List.of(2,4,4,3,3);
    this.m33244.werteNachHinten(3);
    Assertions.assertEquals(
      erwartet
    , this.m33244.getMesswerte(), "Fehler fuer " + vorher + " und 3");
  }   

  @Test
  public void test02(){
    List<Integer> vorher = (List<Integer>) this.m27.getMesswerte().clone();
    List<Integer> erwartet = List.of(7,2);
    this.m27.werteNachHinten(2);
    Assertions.assertEquals(
      erwartet
    , this.m27.getMesswerte(), "Fehler fuer " + vorher + " und 2");
  }

  @Test
  public void test03(){
    List<Integer> vorher = (List<Integer>) this.m3.getMesswerte().clone();
    List<Integer> erwartet = List.of(3);
    this.m3.werteNachHinten(2);
    Assertions.assertEquals(
      erwartet
    , this.m3.getMesswerte(), "Fehler fuer " + vorher + " und 2");
  }

  @Test
  public void test04(){
    List<Integer> vorher = (List<Integer>) this.leer.getMesswerte().clone();
    List<Integer> erwartet = List.of();
    this.leer.werteNachHinten(2);
    Assertions.assertEquals(
      erwartet
    , this.leer.getMesswerte(), "Fehler fuer " + vorher + " und 2");
  }

  @Test
  public void test05(){
    List<Integer> erwartet = null;
    this.mitNullListe.werteNachHinten(2);
    Assertions.assertEquals(
      erwartet
    , this.mitNullListe.getMesswerte(), "Fehler fuer " + null + " und 2");
  }

  @Test
  public void test06(){
    List<Integer> vorher = (List<Integer>) this.m3.getMesswerte().clone();
    List<Integer> erwartet = List.of(3);
    this.m3.werteNachHinten(3);
    Assertions.assertEquals(
      erwartet
    , this.m3.getMesswerte(), "Fehler fuer " + vorher + " und 2");
  }

  @Test
  public void test07(){
    List<Integer> vorher = (List<Integer>) this.m33244.getMesswerte().clone();
    List<Integer> erwartet = List.of(3,3,4,4,2);
    this.m33244.werteNachHinten(2);
    Assertions.assertEquals(
      erwartet
    , this.m33244.getMesswerte(), "Fehler fuer " + vorher + " und  2");
  } 

  @Test
  public void test08(){
    List<Integer> vorher = (List<Integer>) this.m33244.getMesswerte().clone();
    List<Integer> erwartet = List.of(3,3,2,4,4);
    this.m33244.werteNachHinten(4);
    Assertions.assertEquals(
      erwartet
    , this.m33244.getMesswerte(), "Fehler fuer " + vorher + " und  4");
  } 

  @Test
  public void test09(){
    List<Integer> vorher = (List<Integer>) this.m33244.getMesswerte().clone();
    List<Integer> erwartet = List.of(3,3,2,4,4);
    this.m33244.werteNachHinten(5);
    Assertions.assertEquals(
      erwartet
    , this.m33244.getMesswerte(), "Fehler fuer " + vorher + " und  5");
  }
}
